(
        ant.f

        Implementation of Langton's Ants for TForth
        Now featuring COLORS!
)

dict ant
use ant

140 constant xsize
c8 constant ysize
0 var xpos
0 var ypos
1 var dirx
0 var diry
0 var offset
1 constant mask

: calc  xsize ypos * xpos + -> offset ;
: fetch  offset a000 farc@ ;
: store  offset a000 farc! ;
: flip  fetch  1+  store ;
: left-x  dirx -> diry  0 -> dirx ;
: left-y  diry neg -> dirx  0 -> diry ;
: left  dirx if  left-x  ;then  left-y ;
: right-x  dirx neg -> diry  0 -> dirx ;
: right-y  diry -> dirx  0 -> diry ;
: right  dirx if  right-x  ;then  right-y ;
: xmod  xpos xsize = if 0 -> xpos ;then xpos -1 = if xsize 1- -> xpos then ;
: ymod  ypos ysize = if 0 -> ypos ;then ypos -1 = if ysize 1- -> ypos then ;
: move  xpos dirx + -> xpos xmod  ypos diry + -> ypos ymod  calc ;
: turn  fetch  mask and  if  left  ;then  right ;
: step  move turn flip ;
: clear  ysize for  0 r@ xsize 0 gfx-xline13  next ;
: init-pal1  80 for  0 r@ 2/       0  r@      gfx-setpal  next ;
: init-pal2  80 for  0 7f r@ - 2/  0  r@ 80 + gfx-setpal  next ;
: init-pal  init-pal1 init-pal2 ;
: init  13 gfx-mode  xsize 2/ -> xpos  ysize 2/ -> ypos  init-pal clear ;
: stop  3 gfx-mode ;
: run  init  begin  step key?  until  key drop  stop ;

leave ant
