(
        bf.f

        Tired of Forth? Define your words in BrainFuck

        The BrainFuck pointer points at TOS from the start, one step up
        is NOS, etc., and down from the start is some free space on the
        stack. Note that brainfuck words can't change the number of words
        on the stack.

        Examples:

        bf: add  [->+<]  ;  ( a b -- a+b 0 )
        bf: zero  [-]  ;    ( a -- 0 )
)

: bf+  07ff , ;
: bf-  0fff , ;
: bf>  4343 , ;
: bf<  4b4b , ;
: bf[  b9 c,  here 0 , ;
: bf]  here over 2+ - over !  3f81 , 0 , 0374 ,  2+ ,jump ;
: bf;  5b c, ['] exit ,jump ;
: instr-bf ( c -- )
  case:
    [char] + opt bf+
    [char] - opt bf-
    [char] < opt bf<
    [char] > opt bf>
    [char] [ opt bf[
    [char] ] opt bf]
  ;case
  [char] ; = if  bf; r> drop  ;then ;
: compile-bf ( -- )
  input instr-bf tail;

: bf:  :  0 mode !  [compile] sp [compile] (;code) bf< compile-bf ;
