(
        oldant.f

        Implementation of Langton's Ants for TForth
        Robert stling - http://robos.org/
)

dict oldant
use oldant

9 constant color
140 constant xsize
c8 constant ysize
0 var xpos
0 var ypos
1 var dirx
0 var diry
0 var offset

: calc  xsize ypos * xpos + -> offset ;
: fetch  offset a000 farc@ ;
: store  offset a000 farc! ;
: flip  fetch  color xor  store ;
: left-x  dirx -> diry  0 -> dirx ;
: left-y  diry neg -> dirx  0 -> diry ;
: left  dirx if  left-x  ;then  left-y ;
: right-x  dirx neg -> diry  0 -> dirx ;
: right-y  diry -> dirx  0 -> diry ;
: right  dirx if  right-x  ;then  right-y ;
: xmod  xpos xsize = if 0 -> xpos ;then xpos -1 = if xsize 1- -> xpos then ;
: ymod  ypos ysize = if 0 -> ypos ;then ypos -1 = if ysize 1- -> ypos then ;
: move  xpos dirx + -> xpos xmod  ypos diry + -> ypos ymod  calc ;
: turn  fetch if  left  ;then  right ;
: step  move turn flip ;
: clear  ysize for  0 r@ xsize 0 gfx-xline13  next ;
: init  13 gfx-mode  xsize 2/ -> xpos  ysize 2/ -> ypos  clear ;
: stop  3 gfx-mode ;
: run  init  begin  step key?  until  key drop  stop ;

leave oldant
