(
        core.f

        Some basic words that are not needed in the kernel.
)

: immediate  ( -- ) last 2+ 2+ dup c@ 1 or swap c! ;
: [  ( -- ) 0 mode ! ; immediate
: ]  ( -- ) 1 mode ! ;

: if   ( -- a )    (compile) (?nbranch) here 0 , ; immediate
: else ( a -- a )  (compile) (branch) here 0 , swap here swap ! ; immediate
: then ( a -- )    here swap ! ; immediate
: ;then ( a -- )   (compile) exit here swap ! ; immediate

: ' ( -- a )
  read word  lookup ?dup                ( Read a word and look it up )
  if  2+ @  ;then                       ( If it was found, return code ptr )
  cr word print 3f emit cr 0 ;          ( Otherwise, print error message )
: [compile] (compile) (compile) ' , ;   ( Delay compilation of next word )
  immediate
: compile  [compile] (compile) ' , ;    ( Compile next word in input stream )
: ['] [compile] (lit) ' , ; immediate   ( Compile literal, pushing address )

: recurse  last 2+ @ , ; immediate
: tail  [compile] (branch) last 2+ @ 3+ , ; immediate
: tail;  [compile] (branch) last 2+ @ 3+ ,  0 mode ! ; immediate

: ,next   ( -- )  ad c,  ffe0 , ;
: ,call   ( a -- ) e8 c,  here 2+ - , ;
: ,jump   ( a -- ) e9 c,  here 2+ - , ;
: (,call) param  e8 c, here 2+ - , ;
: ;code   r>  last 2+ @  1+ dup>r 2+ - r> ! ;
: does>   [compile] ;code (,call) (does) ; immediate

: (?:)
  if param param drop execute ;then
  param drop param execute ;
: ?:  [compile] (?:)  compile compile ; immediate

: create  ( -- )
  read word header                      ( Create word header )
  ['] (variable) ,call ;                ( Compile call to runtime word )
: create-own ( n -- )
  read word header ,call ;              ( Compile call to your own function )
: #  [compile] (lit)  , ; immediate     ( Like literal, but shorter )

: new:  ' word header  dup e9 swap c!   ( Replace call with jump )
        1+ dup  here - neg 2-  swap !   ( Write jump offset )
        (,call) nest                    ( Compile nest to new word )
        ] ;                             ( Enter compilation mode )
: ::  ( -- a )  here ['] nest ,call  1 mode ! ;

: alias  ( a -- ) read word header  last 2+ ! ;
: allot  ( a -- ) here + dp! ;
: char   ( -- c ) read word 1+ c@ ;
: [char] ( -- )   [compile] (lit) read word 1+ c@ , ; immediate
' 2+ alias cell+
' 2- alias cell-
' 2* alias cells

: depth  sp0 sp - 2/ ;
