; mouse.asm
;
; Words to use mouse drivers.

; mouse-init ( -- true | false )
; mouse-show ( -- )
; mouse-hide ( -- )
; mouse-text ( -- )
; mouse-update ( -- )
; 0 var mouse-x
; 0 var mouse-y
; 0 var mouse-btn

; mouse-init ( -- true | false )
header code_mouse_init,"mouse-init",flag_none
code_mouse_init:
        push    bx
        xor     ax,ax                   ; Reset driver.
        int     0x33
        xchg    ax,bx                   ; TOS = mouse driver?
        next

; mouse-show ( -- )
header code_mouse_show,"mouse-show",flag_none
code_mouse_show:
        mov     ax,0x0001
        int     0x33
        next

; mouse-hide ( -- )
header code_mouse_hide,"mouse-hide",flag_none
code_mouse_hide:
        mov     ax,0x0002
        int     0x33
        next

; mouse-text ( -- )
header code_mouse_text,"mouse-text",flag_none
code_mouse_text:
        push    bx
        mov     ax,0x0003
        int     0x33
        shr     cx,3
        shr     dx,3
        mov     [var_mouse_x],cx
        mov     [var_mouse_y],dx
        mov     [var_mouse_btn],bx
        pop     bx
        next

; mouse-update ( -- )
header code_mouse_update,"mouse-update",flag_none
code_mouse_update:
        push    bx
        mov     ax,0x0003
        int     0x33
        mov     [var_mouse_x],cx
        mov     [var_mouse_y],dx
        mov     [var_mouse_btn],bx
        pop     bx
        next

; 0 var mouse-x
header code_mouse_x,"mouse-x",flag_none
code_mouse_x:
        call    code_do_constant
var_mouse_x     dw      0

; 0 var mouse-y
header code_mouse_y,"mouse-y",flag_none
code_mouse_y:
        call    code_do_constant
var_mouse_y     dw      0

; 0 var mouse-btn
header code_mouse_btn,"mouse-btn",flag_none
code_mouse_btn:
        call    code_do_constant
var_mouse_btn   dw      0

