(
        string.f

        Parsing and string handling words.
)

: spaces ( n -- )  for space next ;
: parse ( s c -- )
  swap dup>r 1+                         ( Save count address )
  begin
    input dup>r 2 pick = if             ( End character yet? )
      r> drop r@ - 1- r> c! drop        ( Store count and quit )
      exit
    then
    r> over c! 1+                       ( No, compile char and repeat )
  again ;
: ,"
  here dup [char] " parse               ( Read string )
  c@ 1+ allot ;                         ( Allocate space for it )
: s"-compile
  [compile] (branch) here >r 0 ,        ( Jump past the string )
  here ," dup c@ + 1+                   ( Compile it in )
  r@ !  [compile] (lit) r> 2+ , ;       ( Push string address )
: s"-interpret
  here ," ;
: s" ( -- a )
  mode @ mode-interpret = if
    s"-interpret exit
  then s"-compile ; immediate
: ." ( -- )
  s"-compile [compile] print ; immediate
: print-fill ( a n -- )
  swap dup c@ swap print - spaces ;
