; macros.asm
;
; Some useful NASM macros, and constants.

%define flag_none       0
%define flag_immediate  1

%define mode_interpret  0
%define mode_compile    1

%xdefine last_header    0


; header code_ptr,"word-name",flags
%macro header 3
%%new_header:
        dw      last_header
%xdefine last_header %%new_header
        dw      %1
        db      %3
        db      (%%name-$-1)
        db      %2
%%name:
        dw      %%new_header
%endmacro

%macro next 0
        lodsw                           ; Load address at IP.
        jmp     ax                      ; Jump to the address.
%endmacro

; OK, this is ugly. About 20 bytes, that's alot for a function call.
; Must think of some way to get around this, maybe make the functions
; using it high-level?

%macro hl_call 1
        xchg    bp,sp
        push    si
        xchg    bp,sp                   ; Push IP to return stack.
        mov     si,%%return_address     ; This is where we will return to.
        jmp     %1
%%return_address:
        dw      %%return_point
%%return_point:
        xchg    bp,sp
        pop     si
        xchg    bp,sp                   ; Pop IP from return stack.
%endmacro
